-- cube.lua
-- Copyright (c) 2004 Marcio M. Andrade

-- A simple 3D rotating cube example

fg = prgb(255,255,0)
bg = prgb(0,0,0)
pcolor(fg,bg)
pclear()

w,h = pmode()
dx,dy = w/2,h/2
cx,cy = (w-dx)/2,(h-dy)/2
buf = pnewbuffer(dx,dy)

c,s = {},{}
for i = 0,360 do
  c[i],s[i] = cos(i),sin(i)
end

f = w/8
x,y,z = {},{},{}
x[1], y[1], z[1] = f,f,-f
x[2], y[2], z[2] = -f,-f,-f
x[3], y[3], z[3] = -f,f,-f
x[4], y[4], z[4] = f,-f,-f
x[5], y[5], z[5] = f,f,f
x[6], y[6], z[6] = -f,-f,f
x[7], y[7], z[7] = -f,f,f
x[8], y[8], z[8] = f,-f,f

x[9], y[9], z[9] = 0,0,-f
x[10], y[10], z[10] = 0,0,f
x[11], y[11], z[11] = f,0,0
x[12], y[12], z[12] = 0,-f,0
x[13], y[13], z[13] = -f,0,0
x[14], y[14], z[14] = 0,f,0

x2,y2,z2 = {},{},{}
x3,y3 = {},{}

face ={}
face[1] = {1,3,2,4}
face[2] = {5,7,6,8}
face[3] = {1,5,8,4}
face[4] = {4,8,6,2}
face[5] = {2,6,7,3}
face[6] = {3,7,5,1}

normal = {9,10,11,12,13,14}

xcenter,ycenter,zcenter = dx/2,dy/2,256
pa,ta = 0,0
pm,tm = 5,4
ix,iy = 3.1,2.3

while 1 do
  st,ct,sp,cp = s[ta],c[ta],s[pa],c[pa]

  for i = 1,14 do
    xi,yi,zi = x[i],y[i],z[i]

    x2[i] = xi
    y2[i] = yi*ct - zi*st
    z2[i] = yi*st + zi*ct

    xi,yi,zi = x2[i],y2[i],z2[i]
    x2[i] = xi*ct - zi*st
    y2[i] = yi
    z2[i] = xi*st +zi*ct

    xi,yi,zi = x2[i],y2[i],z2[i]
    x2[i] = xi*ct - yi*st
    y2[i] = xi*st + yi*ct
    z2[i] = zi
  end

  for i = 1,14 do
    x3[i] = 256 * (x2[i] / (z2[i] + zcenter)) + xcenter
    y3[i] = 256 * (y2[i] / (z2[i] + zcenter)) + ycenter
  end

  pusebuffer(buf)
  pcolor(fg,bg)
  pclear()

  for i = 1,6 do
    n = normal[i]
    nx,ny,nz = x2[n],y2[n],z2[n]
    fa = face[i]
    p = fa[1]
    vz = -2*f
    mn = sqrt(nx*nx+ny*ny+nz*nz)
    mv = -vz
    pr = vz*nz
    co = pr/(mn*mv)
    if co > 0.15 then
    pline(x3[fa[1]], y3[fa[1]], x3[fa[2]], y3[fa[2]])
    pline(x3[fa[2]], y3[fa[2]], x3[fa[3]], y3[fa[3]])
    pline(x3[fa[3]], y3[fa[3]], x3[fa[4]], y3[fa[4]])
    pline(x3[fa[4]], y3[fa[4]], x3[fa[1]], y3[fa[1]])
    end
    end

  pusebuffer()
  pputbuffer(buf,cx,cy)

  pa,ta = pa + pm,ta + tm
  if pa >= 360 then pa = pa - 360 end
  if ta >= 360 then ta = ta - 360 end

  cx,cy = cx + ix,cy + iy
  if cx < 0 then cx,ix = 0,-ix end
  if cx > w-dx then cx,ix = w-dx,-ix end
  if cy < 0 then cy,iy = 0,-iy end
  if cy > h-dy then cy,iy = h-dy,-iy end

  e=pevent(10)
  if e==keyDown then break end
end
pfreebuffer(buf)
